| Qore Programming Language Reference Manual 1.0.8

Public Member Functions | List of all members
Qore::EncodingConversionOutputStream Class Reference

An OutputStream implementation that performs on-the-fly conversion between two character encodings. More...

Inheritance diagram for Qore::EncodingConversionOutputStream:
[legend]

## Public Member Functions
nothing | close ()
| Flushes any buffered (unwritten) bytes, closes the output stream and releases all resources. More...
| constructor (Qore::OutputStream os, string sourceEncoding, string destEncoding)
| Creates the EncodingConversionOutputStream based on the OutputStream given. More...
nothing | write (binary data)
| Writes bytes to the output stream. More...
Public Member Functions inherited from Qore::OutputStream
| constructor ()
| Constructor. More...
Public Member Functions inherited from Qore::StreamBase
| constructor ()
| Throws an exception if called directly; this class can only be instantiated by builtin subclasses. More...
int | getThreadId ()
| Get the currently assigned thread id or -1 if not assigned to any thread.
nothing | reassignThread ()
| Reassigns current thread as thread used for stream manipulation. More...
nothing | unassignThread ()
| Unassigns current thread as thread used for stream manipulation. More...

## Detailed Description

An OutputStream implementation that performs on-the-fly conversion between two character encodings.

Example: EncodingConversionOutputStream basic usage
  EncodingConversionOutputStream latin2Stream(destUtf8Stream, "ISO-8859-2", "UTF-8");
  latin2Stream.write(latin2Data); #writes UTF-8 equivalents to destUtf8Stream

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown, unless the stream is handed off to another thread using the StreamBase::unassignThread() method in the thread that currently owns the stream, and the StreamBase::reassignThread() method in the new thread.

See also
  StreamWriter for a class that can be used to write various kinds of data to an OutputStream

Since
  Qore 0.8.13

## Member Function Documentation

## ◆ close()

nothing Qore::EncodingConversionOutputStream::close | ( |  | ) |
| virtual

Flushes any buffered (unwritten) bytes, closes the output stream and releases all resources.

Any methods called on a closed output stream will throw an exception.

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::OutputStream.

## ◆ constructor()

Qore::EncodingConversionOutputStream::constructor | ( | Qore::OutputStream | os,
|  | string | sourceEncoding,
|  | string | destEncoding
| ) |  |

Creates the EncodingConversionOutputStream based on the OutputStream given.

Parameters

  os | the destination OutputStream to write bytes to
  sourceEncoding | the encoding of the characters that will be written to this stream
  destEncoding | the destination character encoding that will be written to the underlying OutputStream os

Exceptions

  ENCODING-CONVERSION-ERROR | if either of the encodings is unsupported

## ◆ write()

nothing Qore::EncodingConversionOutputStream::write | ( | binary | data | ) |
| virtual

Writes bytes to the output stream.

Parameters

  data | the data to write

Example:
  EncodingConversionOutputStream ecos();
  bos.write(<6162>);
  bos.write(<63>);

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::OutputStream.